# -*- coding: UTF-8 -*-
#       10.11.2013
# --- [ SerPort.py ] -----------------------------------------------------------
#
import serial
import sys

# ------------------------------------------------------------------------------
def open(start = 1, end = 13):
    """Prüft, ob sich die Ports COM1: bis COM13: öffnen lassen
       gibt eine Liste der öffenbaren Ports zurück.
       Falls genau 1 Port gefunden wurde, wird dieser geöffnet.
       Werden mehrere gefunden, dann kann eine Vorgabe unter
       "default_comport" festgelegt werden.

       Rückgabe: serielle Schnittstelle
    """
    ports = []
    comport = None
    default_comport = 1

# Die Ports können als "COM1" .. "COM10" oder
# über eine Ziffer      0     ..  9 angesprochen werden

    opsys = sys.platform
    if opsys == "win32":
        for i in range(start, end):
            try:
                p  = "COM" + str(i)
                rx = serial.Serial(p)
                rx.close()
                ports.append(p)

            except IOError:
                pass

    elif op.sys == "linux2":
        # Vielleicht arbeiten wir auf einem RaspberryPi ??
        try:
            p = "/dev/ttyAMA0"
            rx = serial.Serial(p)
            rx.close()
            ports.append(p)

        except IOError:
            pass

    else:
        print("OS =", opsys )
        print("quit")
        exit()

    print("Freie Ports: ", ports)

    if len(ports) == 1:     # genau ein freier Port gefunden
        comport = serial.Serial(ports[0], 9600, rtscts = False)
        print("geöffnet :", comport.name)

    elif len(ports) == 0:   # Kein freier Port gefunden
        print("Kein freier Port gefunden !")
        exit()

    else:                   # mehrere freie Ports gefunden
        if default_comport in ports:
            comport = serial.Serial(default_comport, 9600)
            print("geöffnet : ", default_comport)

        else:
            print("welcher Port soll geöffnet werden ?")
            exit()

    return comport

if __name__ == "__main__":
    print(open())

# --- [ eof ] ------------------------------------------------------------------
