#!/usr/bin/python
# -*- coding: UTF-8 -*-
#  02.12.2013

# Testdatei
# wie main_b, hier werden die empfangenen Daten an self.myFunc() übergeben
# von dort aus wird xbee_help.x_print() bemüht.

import atexit
import time
import xbee
import SerPort
import xbee_help

class App(object):
    def __init__(self):
        self.ser = SerPort.open()
        self.X_adr = None
        self.start()

    def receive(self, station, frame):
        """ Wird als Callback-Funktion an das Objekt Xbee() übergeben und
        liefert folgende Daten zurück:
        - station = Index des Absenders in der Senderliste,
        - frame = komplettes Frame als Bytefolge (ohne abschließende Prüfsumme).
        Die Frames 0x88, 0x8B und 0x97 werden im Normalfall vom rxHandler
        interpretiert und kommen hier nicht an !
        """
        # die Daten zur Interpretation an xbee_help weiterreichen
        xbee_help.x_print(frame)


    def myFunc(self, station, frame):
        """ Benutzerdefinierte Funktion zur Bearbeitung der Rückmeldungen """
        xbee_help.x_print(frame)


    def start(self):
        self.X = xbee.Xbee(ser = self.ser, callback = self.receive, logToTTY = False)
        atexit.register(self.X.exit)

        # ruft 5x ein Remote AT-Command aus der Liste auf
        # das muss immer funktionieren, auf wenn die Stationslist nicht aktuell ist
        # es muss aber der Coordinator vorhanden sein !
        # die empfangenen Daten werden von receive() ausgegeben
        j = 5
        cmdlist = ("MY", "SH", "SL", "DB", "D1")
        try:
            while j:
                j -= 1
                cmd = cmdlist[j]
                self.X.sendRemoteAtCmd(dev = 0, atcmd = cmd, rxHandler = self.myFunc)
                time.sleep(1)

        except KeyboardInterrupt:
            self.X.exit()
            exit()

        time.sleep(1)
        # die Stationliste ausgeben, auf wenn das Loggen deaktiviert ist
        self.X.config(logToTTY = True)
        self.X.X_adr.printStationList()
        self.X.exit()
        exit()

if __name__ == "__main__":
    App()


# --- [ eof ] ------------------------------------------------------------------